# generated by datamodel-codegen:
#   filename:  openapi.json
#   timestamp: 2023-08-31T15:20:23+00:00

from __future__ import annotations

from typing import Optional

from pydantic import Field

from kelvin.sdk.client.data_model import DataModelBase


class PaginationInfo(DataModelBase):
    """
    PaginationInfo object.

    Parameters
    ----------
    next_page: Optional[str]
    page: Optional[int]
    page_size: Optional[int]
    previous_page: Optional[str]
    total_items: Optional[int]
    total_pages: Optional[int]

    """

    next_page: Optional[str] = Field(
        None,
        description="Bookmark the last object in returned list for use with starting_after parameter in future list API requests.",
    )
    page: Optional[int] = Field(None, description="The page number of the current results.")
    page_size: Optional[int] = Field(
        None, description="The number of objects returned in the current results"
    )
    previous_page: Optional[str] = Field(
        None,
        description="Bookmark the first object in returned list for use with ending_before parameter in future list API requests.",
    )
    total_items: Optional[int] = Field(
        None,
        description="Total number of objects after all filters in the query parameters have been performed. This includes the objects in the current results.",
    )
    total_pages: Optional[int] = Field(
        None,
        description="Total number of pages available after all filters in the query parameters have been performed. This includes the current page in the total amount.",
    )
