# generated by datamodel-codegen:
#   filename:  openapi.json
#   timestamp: 2023-08-31T15:20:23+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import Extra, Field

from kelvin.sdk.client.base_model import BaseModelRoot
from kelvin.sdk.client.data_model import DataModelBase


class AppCreate(DataModelBase):
    """
    AppCreate object.

    Parameters
    ----------
    manifest: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    manifest: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None


class AppExtraField(DataModelBase):
    """
    AppExtraField object.

    Parameters
    ----------
    app_name: Optional[str]
    app_versions: Optional[List[str]]
    name: Optional[str]
    statuses: Optional[List[str]]

    """

    app_name: Optional[str] = None
    app_versions: Optional[List[str]] = None
    name: Optional[str] = None
    statuses: Optional[List[str]] = None


class AppUpdate(DataModelBase):
    """
    AppUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AssetInsightsSortBy(DataModelBase):
    """
    AssetInsightsSortBy object.

    Parameters
    ----------
    direction: Optional[str]
    field: Optional[str]
    sort_by_extra_field: Optional[bool]

    """

    direction: Optional[str] = Field(
        "asc",
        description="Sorting order for the results according to the `field` parameter.</p> There are two options; `asc` (ascending order) and `desc` (descending order).</p> The default is `asc` (ascending).",
    )
    field: Optional[str] = Field(
        "name",
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> or `extra_field` field to sort by. Source of field will be determined by the `SortByExtraField` key.",
    )
    sort_by_extra_field: Optional[bool] = Field(
        None,
        description="Choose the source of the `field` parameter. If `false`, the field name will be from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> names. If `true`, the field name will be from the `extra_field[].name` field.",
    )


class AssetList(DataModelBase):
    """
    AssetList object.

    Parameters
    ----------
    asset_type_name: Optional[List[str]]
    entity_type_name: Optional[List[str]]
    names: Optional[List[str]]
    properties: Optional[List[str]]
    properties_filter: Optional[List[str]]
    search: Optional[List[str]]
    status_state: Optional[List[str]]

    """

    asset_type_name: Optional[List[str]] = Field(
        None,
        description="Filter on the parameter <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> by its name. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a filter with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> with the name `pump` but not with the names `pumps` or `centrifugal-fan`.",
    )
    entity_type_name: Optional[List[str]] = Field(
        None,
        description="Filter and return the results of one or more of the entity type names. This is given as an array, for example `[group,asset]`. Prefix any entity type name with the character `!` for a NOT operation.</p> There are five entity type names available to choose from; `group`, `asset`, `component`, `part`, `sensor`.</p> The default will select all available entity type name options.</p>",
    )
    names: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> parameter `name`. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> with the name `pump` but not with the names `pumps` or `centrifugal-fan`.",
    )
    properties: Optional[List[str]] = Field(
        None,
        description="Only returns specified properties in each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This does not filter the array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> returned, only filters the properties in each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>. If the property does not exist in a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>, then the properties parameter is returned with no contents. If this is the only parameter used, then all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> will be returned.</p> The default is to return all properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    properties_filter: Optional[List[str]] = Field(
        None,
        description="Filter <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> that contain a property with a specified value. The property must be declared using its `name` and not its `title` (Display Name). Multiple properties or multiple values can be filtered within this array. For example `[demo_property=demo_value]` or `[demo_property_1=demo_value,demo_property_2=88]`.</p> All values to be filtered must be an exact match and is case sensitive. Also there must be no spaces before or after the equal sign.</p> For example; `[demo_property=88]` is accepted but `[demo_property = 88]` will cause a 400 error.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Search and filter the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> list. Both the Display Name and the Name will be included in the search field criteria. This is given as an array, for example `[pump,fan]`.</p> The search is case insensitive and will find partial matches as well. For example if a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name or display name is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )
    status_state: Optional[List[str]] = Field(
        None,
        description="Filter <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> by its current status. Multiple parameters can be given in an array, for example `[online,partially_online]` and will be filtered as `OR`.</p> There are four parameter options; `online`, `offline`, `partially_online` and `unknown`.",
    )


class AssetPropertyCreate(DataModelBase):
    """
    AssetPropertyCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Unique identifier name for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: Optional[str] = Field(
        None,
        description='Display name (title) for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    value: Optional[str] = Field(None, description="Value for this property.")


class AssetPropertyExtraField(DataModelBase):
    """
    AssetPropertyExtraField object.

    Parameters
    ----------
    name: Optional[str]
    property_name: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> `extra_field`.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    property_name: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> property to include.</p> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> properties are custom fields that can be created with the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )


class AssetTypeCreate(DataModelBase):
    """
    AssetTypeCreate object.

    Parameters
    ----------
    name: str
    title: str

    """

    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='Display name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetTypeUpdate(DataModelBase):
    """
    AssetTypeUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(
        None,
        description='New display name(title) for this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class BridgeDeploy(DataModelBase):
    """
    BridgeDeploy object.

    Parameters
    ----------
    cluster_name: str
    name: str
    payload: Dict[str, Any]
    protocol: str
    title: str

    """

    cluster_name: str = Field(
        ...,
        description="Unique identifier name of an existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="Custom JSON object holding all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs and their communication specifications and addresses.</p> This JSON structure will depend on the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> bring deployed. The type is the Protocol parameter here.",
    )
    protocol: str = Field(
        ...,
        description="This is the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> communication protocol. There are four protocols available; `opc-ua`, `mqtt`, `modbus`, `roc`. Full details about these protocols are explained in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Documentation Overview</a>",
        max_length=64,
    )
    title: str = Field(
        ...,
        description="Display name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class BulkParameterUpdate(DataModelBase):
    """
    BulkParameterUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]
    resources: List[str]

    """

    payload: Dict[str, Any]
    resources: List[str]


class ClusterCreate(DataModelBase):
    """
    ClusterCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    type: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = None
    type: Optional[str] = Field(None, max_length=64)


class ClusterSettingAutoUpdate(DataModelBase):
    """
    ClusterSettingAutoUpdate object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ClusterSettingForwardLogs(DataModelBase):
    """
    ClusterSettingForwardLogs object.

    Parameters
    ----------
    buffer_size: Optional[int]
    enabled: Optional[bool]

    """

    buffer_size: Optional[int] = None
    enabled: Optional[bool] = None


class ClusterSettingSync(DataModelBase):
    """
    ClusterSettingSync object.

    Parameters
    ----------
    interval: Optional[int]

    """

    interval: Optional[int] = None


class ClusterSettingTelemetry(DataModelBase):
    """
    ClusterSettingTelemetry object.

    Parameters
    ----------
    buffer_size: Optional[int]
    enabled: Optional[bool]
    scrape_interval: Optional[int]

    """

    buffer_size: Optional[int] = None
    enabled: Optional[bool] = None
    scrape_interval: Optional[int] = None


class ClusterVersions(DataModelBase):
    """
    ClusterVersions object.

    Parameters
    ----------
    k8s_version: Optional[str]
    kelvin_version: Optional[str]

    """

    k8s_version: Optional[str] = None
    kelvin_version: Optional[str] = None


class ControlChangeClustering(DataModelBase):
    """
    ControlChangeClustering object.

    Parameters
    ----------
    end_date: datetime
    resources: Optional[List[str]]
    sources: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    time_bucket: str

    """

    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    resources: Optional[List[str]] = Field(
        None,
        description="Filter on krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    sources: Optional[List[str]] = None
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    time_bucket: str = Field(
        ...,
        description="Time window to group and aggregate the occurrence of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a> within the defined time bucket.</p> Bucket time options available can be found at <a href='https://golang.org/pkg/time/#ParseDuration' target='_blank'>https://golang.org/pkg/time/#ParseDuration</a>. For example '1h', '1m' or '2h45m'.",
    )


class ControlChangeCreate(DataModelBase):
    """
    ControlChangeCreate object.

    Parameters
    ----------
    expiration_date: Optional[datetime]
    payload: Optional[Dict[str, Any]]
    resource: str
    retry: Optional[int]
    timeout: Optional[int]

    """

    expiration_date: Optional[datetime] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON structure with a `value` key and the new value to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.</p> For example </p> <blockquote>\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 888</br>}</blockquote>",
    )
    resource: str = Field(
        ...,
        description="krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=256,
    )
    retry: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send an `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class ControlChangeExtraField(DataModelBase):
    """
    ControlChangeExtraField object.

    Parameters
    ----------
    datastreams: Optional[List[str]]
    name: Optional[str]
    statuses: Optional[List[str]]

    """

    datastreams: Optional[List[str]] = None
    name: Optional[str] = None
    statuses: Optional[List[str]] = None


class ControlChangeLast(DataModelBase):
    """
    ControlChangeLast object.

    Parameters
    ----------
    resources: List[str]
    sources: Optional[List[str]]
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    resources: List[str] = Field(
        ...,
        description="Filter on krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    sources: Optional[List[str]] = None
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class Id(BaseModelRoot[str]):
    """
    Id object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeList(DataModelBase):
    """
    ControlChangeList object.

    Parameters
    ----------
    ids: Optional[List[Id]]
    resources: Optional[List[str]]
    sources: Optional[List[str]]
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    ids: Optional[List[Id]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> IDs, to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only UUID type strings.",
    )
    resources: Optional[List[str]] = Field(
        None,
        description="Filter on krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    sources: Optional[List[str]] = None
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class ControlChangeRange(DataModelBase):
    """
    ControlChangeRange object.

    Parameters
    ----------
    end_date: datetime
    resources: List[str]
    sources: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    resources: List[str] = Field(
        ...,
        description="Filter on krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    sources: Optional[List[str]] = None
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class DataStreamContextList(DataModelBase):
    """
    DataStreamContextList object.

    Parameters
    ----------
    datastream_names: Optional[List[str]]
    resources: Optional[List[str]]
    sources: Optional[List[str]]

    """

    datastream_names: Optional[List[str]] = None
    resources: Optional[List[str]] = None
    sources: Optional[List[str]] = None


class Type(Enum):
    computed = "computed"
    measurement = "measurement"


class DataStreamCreate(DataModelBase):
    """
    DataStreamCreate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    description: Optional[str]
    name: str
    primitive_type_name: str
    semantic_type_name: str
    title: str
    type: Type
    unit_name: Optional[str]

    """

    data_type_name: Optional[str] = Field(None, max_length=64, min_length=1)
    description: Optional[str] = Field(None, max_length=200, min_length=1)
    name: str = Field(..., max_length=64, min_length=1)
    primitive_type_name: str = Field(..., max_length=64, min_length=1)
    semantic_type_name: str = Field(..., max_length=64, min_length=1)
    title: str = Field(..., max_length=64, min_length=1)
    type: Type
    unit_name: Optional[str] = Field(None, max_length=64, min_length=1)


class DataStreamList(DataModelBase):
    """
    DataStreamList object.

    Parameters
    ----------
    data_type_names: Optional[List[str]]
    names: Optional[List[str]]
    primitive_type_names: Optional[List[str]]
    search: Optional[List[str]]
    semantic_type_names: Optional[List[str]]
    unit_names: Optional[List[str]]

    """

    data_type_names: Optional[List[str]] = None
    names: Optional[List[str]] = None
    primitive_type_names: Optional[List[str]] = None
    search: Optional[List[str]] = None
    semantic_type_names: Optional[List[str]] = None
    unit_names: Optional[List[str]] = None


class DataStreamUpdate(DataModelBase):
    """
    DataStreamUpdate object.

    Parameters
    ----------
    description: Optional[str]
    title: Optional[str]

    """

    description: Optional[str] = Field(None, max_length=200, min_length=1)
    title: Optional[str] = Field(None, max_length=64, min_length=1)


class DataTypeCreate(DataModelBase):
    """
    DataTypeCreate object.

    Parameters
    ----------
    name: str
    schema_: Dict[str, Any]
    title: str

    """

    name: str = Field(..., max_length=64, min_length=1)
    schema_: Dict[str, Any] = Field(..., alias="schema")
    title: str = Field(..., max_length=64, min_length=1)


class DataTypeUpdate(DataModelBase):
    """
    DataTypeUpdate object.

    Parameters
    ----------
    schema_: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    schema_: Optional[Dict[str, Any]] = Field(None, alias="schema")
    title: Optional[str] = Field(None, max_length=64, min_length=1)


class DatastreamExtraFieldComputation(DataModelBase):
    """
    DatastreamExtraFieldComputation object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: Optional[str]
    start_time: Optional[str]

    """

    agg: Optional[str] = Field(
        None,
        description="Perform mathematical calculations on a group of data defined by the 'starttime' and 'endtime' keys.</p> For numerical data the mathematical options available are; `count`, `mean`, `sum`, `max` and `min`.</p> For text based data the mathematical options available are; `count`.",
    )
    end_time: Optional[str] = Field(
        None,
        description="The end time for the time range of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metrics</a> related to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to be used by the `agg` key calculations.",
    )
    start_time: Optional[str] = Field(
        None,
        description="The start time for the time range of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metrics</a> related to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to be used by the `agg` key calculations.",
    )


class ExecuteActionRequest(DataModelBase):
    """
    ExecuteActionRequest object.

    Parameters
    ----------
    resources: Optional[List[str]]

    """

    resources: Optional[List[str]] = None


class HierarchyUpdateItem(DataModelBase):
    """
    HierarchyUpdateItem object.

    Parameters
    ----------
    asset_type_name: str
    delete: Optional[bool]
    entity_type_name: str
    hierarchy: Optional[List[HierarchyUpdateItem]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str

    """

    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    delete: Optional[bool] = Field(
        None,
        description="Delete this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> and its complete <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> If this parameter is marked `true`, then only the `name` is required as a parameter. Default is `false`.",
    )
    entity_type_name: str = Field(
        ...,
        description='Unique identifier name of the entity type linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.',
    )
    hierarchy: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A list of all <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a> which will include any <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> that are in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> below this <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a>.",
    )
    name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description='List of any custom properties for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    title: str = Field(
        ...,
        description='Display name (title) of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )


class InstanceSettingUpdate(DataModelBase):
    """
    InstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ListAppsRequest(DataModelBase):
    """
    ListAppsRequest object.

    Parameters
    ----------
    app_names: Optional[List[str]]
    resources: Optional[List[str]]
    search: Optional[str]
    statuses: Optional[List[str]]

    """

    app_names: Optional[List[str]] = None
    resources: Optional[List[str]] = None
    search: Optional[str] = None
    statuses: Optional[List[str]] = None


class ListResourcesRequest(DataModelBase):
    """
    ListResourcesRequest object.

    Parameters
    ----------
    app_versions: Optional[List[str]]
    enabled_states: Optional[List[bool]]
    resources: Optional[List[str]]
    statuses: Optional[List[str]]

    """

    app_versions: Optional[List[str]] = None
    enabled_states: Optional[List[bool]] = None
    resources: Optional[List[str]] = None
    statuses: Optional[List[str]] = None


class MappingItem(DataModelBase):
    """
    MappingItem object.

    Parameters
    ----------
    app: Optional[str]
    datastream: Optional[str]

    """

    app: Optional[str] = None
    datastream: Optional[str] = None


class Mappings(DataModelBase):
    """
    Mappings object.

    Parameters
    ----------
    inputs: Optional[List[MappingItem]]
    outputs: Optional[List[MappingItem]]

    """

    inputs: Optional[List[MappingItem]] = None
    outputs: Optional[List[MappingItem]] = None


class ParameterAppVersion(DataModelBase):
    """
    ParameterAppVersion object.

    Parameters
    ----------
    name: Optional[str]
    version: Optional[str]

    """

    name: Optional[str] = None
    version: Optional[str] = None


class ParameterList(DataModelBase):
    """
    ParameterList object.

    Parameters
    ----------
    apps: Optional[List[ParameterAppVersion]]
    asset_names: Optional[List[str]]

    """

    apps: Optional[List[ParameterAppVersion]] = Field(
        None, description="An array of App/Version identifiers"
    )
    asset_names: Optional[List[str]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the last <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class ParameterUpdate(DataModelBase):
    """
    ParameterUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]

    """

    payload: Dict[str, Any]


class PlannerRulesUpsertRequest(DataModelBase):
    """
    PlannerRulesUpsertRequest object.

    Parameters
    ----------

    """

    class Config(DataModelBase.Config):
        extra = Extra.allow


class RecommendationAccept(DataModelBase):
    """
    RecommendationAccept object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = Field(
        None,
        description="A string with any descriptions useful to be associated with the `accept` state. This will be recorded in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> logs with the `accept` update.",
    )


class RecommendationClustering(DataModelBase):
    """
    RecommendationClustering object.

    Parameters
    ----------
    end_date: datetime
    resource_names: Optional[List[str]]
    sources: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    time_bucket: str
    types: Optional[List[str]]

    """

    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendations</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    resource_names: Optional[List[str]] = Field(
        None,
        description="An array of all assets or APIs to filter that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> is related to.</p> Each string in the array always starts with `krn:`, then has `asset:`, then the name of the Kelvin Asset.</p> Even though there are other `krn` options it needs to be `asset:` so that it is associated with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will be seen in the Asset List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/' target='_blank'>Kelvin Maps</a>.</p> For example `[\"krn:asset:demo-asset-1\", \"krn:asset:demo-asset-2\"]`",
    )
    sources: Optional[List[str]] = None
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendations</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="An array of `states` to filter as reported by the last status update for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.</p> Possible options are; `pending`, `accepted`, `rejected`, `applied`, `expired` and `error`.",
    )
    time_bucket: str = Field(
        ...,
        description="Time window to group and aggregate the occurrence of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendations</a> within the defined time bucket.</p> Bucket time options available can be found at <a href='https://golang.org/pkg/time/#ParseDuration' target='_blank'>https://golang.org/pkg/time/#ParseDuration</a>. For example '1h' represents one hour buckets.",
    )
    types: Optional[List[str]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> to filter.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a> has a unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a>.</p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> The type must already exist from a list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a>. A full list of available <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> can be retrieved using the api request `/recommendations/types/list`.",
    )


class RecommendationControlChange(DataModelBase):
    """
    RecommendationControlChange object.

    Parameters
    ----------
    expiration_date: Optional[str]
    payload: Dict[str, Any]
    resource: str
    retry: Optional[int]
    timeout: Optional[int]

    """

    expiration_date: Optional[str] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> data to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> Normally this is an object `{ \"value\": 88}`.",
    )
    resource: str = Field(
        ...,
        description="krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    retry: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send a `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class RecommendationCreateLog(DataModelBase):
    """
    RecommendationCreateLog object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = Field(
        None,
        description="A string with any descriptions useful for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> log.",
    )


class RecommendationExtraField(DataModelBase):
    """
    RecommendationExtraField object.

    Parameters
    ----------
    name: Optional[str]
    since: Optional[str]
    source: Optional[str]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    name: Optional[str] = None
    since: Optional[str] = None
    source: Optional[str] = None
    states: Optional[List[str]] = None
    types: Optional[List[str]] = None


class RecommendationLast(DataModelBase):
    """
    RecommendationLast object.

    Parameters
    ----------
    resources: List[str]
    sources: Optional[List[str]]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    resources: List[str] = Field(
        ...,
        description="An array of all assets or APIs to filter that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> is related to.</p> Each string in the array always starts with `krn:`, then has `asset:`, then the name of the Kelvin Asset.</p> Even though there are other `krn` options it needs to be `asset:` so that it is associated with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will be seen in the Asset List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/' target='_blank'>Kelvin Maps</a>.</p> For example `[\"krn:asset:demo-asset-1\", \"krn:asset:demo-asset-2\"]`",
    )
    sources: Optional[List[str]] = None
    states: Optional[List[str]] = Field(
        None,
        description="An array of `states` to filter as reported by the last status update for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.</p> Possible options are; `pending`, `accepted`, `rejected`, `applied`, `expired` and `error`.",
    )
    types: Optional[List[str]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> to filter.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a> has a unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a>.</p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> The type must already exist from a list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a>. A full list of available <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> can be retrieved using the api request `/recommendations/types/list`.",
    )


class RecommendationList(DataModelBase):
    """
    RecommendationList object.

    Parameters
    ----------
    ids: Optional[List[str]]
    resources: Optional[List[str]]
    sources: Optional[List[str]]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    ids: Optional[List[str]] = Field(
        None,
        description="An array of all `id`s to retrieve.</p> An `id` must be made only of hexadecimal numbers and the `-` character.</p> It is a Universally Unique Identifier (UUID) to identify each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.</p>It is a 128-bit identifier generated using random or pseudo-random numbers and consists of 32 hexadecimal digits separated by hyphens into five groups of varying lengths: 8-4-4-4-12.",
    )
    resources: Optional[List[str]] = Field(
        None,
        description="An array of all assets or APIs to filter that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> is related to.</p> Each string in the array always starts with `krn:`, then has `asset:`, then the name of the Kelvin Asset.</p> Even though there are other `krn` options it needs to be `asset:` so that it is associated with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will be seen in the Asset List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/' target='_blank'>Kelvin Maps</a>.</p> For example `[\"krn:asset:demo-asset-1\", \"krn:asset:demo-asset-2\"]`",
    )
    sources: Optional[List[str]] = None
    states: Optional[List[str]] = Field(
        None,
        description="An array of `states` to filter as reported by the last status update for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.</p> Possible options are; `pending`, `accepted`, `rejected`, `applied`, `expired` and `error`.",
    )
    types: Optional[List[str]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> to filter.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a> has a unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a>.</p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> The type must already exist from a list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a>. A full list of available <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> can be retrieved using the api request `/recommendations/types/list`.",
    )


class RecommendationRange(DataModelBase):
    """
    RecommendationRange object.

    Parameters
    ----------
    end_date: datetime
    resources: List[str]
    sources: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendations</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    resources: List[str] = Field(
        ...,
        description="An array of all assets or APIs to filter that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> is related to.</p> Each string in the array always starts with `krn:`, then has `asset:`, then the name of the Kelvin Asset.</p> Even though there are other `krn` options it needs to be `asset:` so that it is associated with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will be seen in the Asset List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/' target='_blank'>Kelvin Maps</a>.</p> For example `[\"krn:asset:demo-asset-1\", \"krn:asset:demo-asset-2\"]`",
    )
    sources: Optional[List[str]] = None
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendations</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="An array of `states` to filter as reported by the last status update for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.</p> Possible options are; `pending`, `accepted`, `rejected`, `applied`, `expired` and `error`.",
    )
    types: Optional[List[str]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> to filter.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a> has a unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a>.</p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> The type must already exist from a list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a>. A full list of available <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> can be retrieved using the api request `/recommendations/types/list`.",
    )


class RecommendationReject(DataModelBase):
    """
    RecommendationReject object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = Field(
        None,
        description="A string with any descriptions useful to be associated with the `rejected` state. This will be recorded in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> logs with the `accept` update.",
    )


class RecommendationTypeCreate(DataModelBase):
    """
    RecommendationTypeCreate object.

    Parameters
    ----------
    description: Optional[str]
    name: str
    title: str

    """

    description: Optional[str] = None
    name: str = Field(..., max_length=64, min_length=1)
    title: str = Field(..., max_length=64, min_length=1)


class RecommendationTypeUpdate(DataModelBase):
    """
    RecommendationTypeUpdate object.

    Parameters
    ----------
    description: Optional[str]
    title: Optional[str]

    """

    description: Optional[str] = None
    title: Optional[str] = Field(None, max_length=64, min_length=1)


class SecretCreate(DataModelBase):
    """
    SecretCreate object.

    Parameters
    ----------
    name: str
    value: str

    """

    name: str = Field(..., max_length=32)
    value: str


class Selector(DataModelBase):
    """
    Selector object.

    Parameters
    ----------
    fields: Optional[List[str]]
    resource: Optional[str]

    """

    fields: Optional[List[str]] = None
    resource: Optional[str] = None


class SemanticTypeCreate(DataModelBase):
    """
    SemanticTypeCreate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    name: str
    primitive_type_name: Optional[str]
    title: str
    unit_names: Optional[List[str]]

    """

    data_type_name: Optional[str] = Field(None, max_length=64)
    name: str = Field(..., max_length=64, min_length=1)
    primitive_type_name: Optional[str] = Field(None, max_length=64)
    title: str = Field(..., max_length=64, min_length=1)
    unit_names: Optional[List[str]] = None


class SemanticTypeUpdate(DataModelBase):
    """
    SemanticTypeUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64, min_length=1)


class TimeseriesCreate(DataModelBase):
    """
    TimeseriesCreate object.

    Parameters
    ----------
    id: Optional[str]
    payload: Optional[Dict[str, Any]]
    resource: Optional[str]
    source: Optional[str]
    timestamp: Optional[datetime]
    type: Optional[str]

    """

    id: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None
    resource: Optional[str] = None
    source: Optional[str] = None
    timestamp: Optional[datetime] = Field(None, example="2022-01-13T12:00:00.000000Z")
    type: Optional[str] = None


class TimeseriesGetLast(DataModelBase):
    """
    TimeseriesGetLast object.

    Parameters
    ----------
    selectors: Optional[List[Selector]]

    """

    selectors: Optional[List[Selector]] = None


class Order(Enum):
    ASC = "ASC"
    DESC = "DESC"


class TimeseriesGetRange(DataModelBase):
    """
    TimeseriesGetRange object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: datetime
    fill: Optional[str]
    group_by_selector: Optional[bool]
    order: Optional[Order]
    selectors: List[Selector]
    start_time: datetime
    time_bucket: Optional[str]
    time_shift: Optional[str]

    """

    agg: Optional[str] = Field(
        None,
        description="Perform mathematical calculations on a group of data.</p> For numerical data there are twelve mathematical options available; `none` , `count`,`distinct`, `integral`, `mean`, `median`, `mode`, `spread`, `stddev`, `sum`, `max`, `min`, `first`, `last`.</p> For text based data there are three types of mathematical options available; `count`, `distinct`, `mode`, `first`, `last`. The default is `none`.</p> When using this parameter, you must also use the parameters `time_bucket` which defines how to group the data and `fields` which defines which payload data to use.",
    )
    end_time: datetime = Field(
        ...,
        description="End time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2023-06-01T12:00:00.000000Z'.",
        example="2023-06-01T12:00:00.000000Z",
    )
    fill: Optional[str] = Field(
        None,
        description="Fills any group of data, which is defined by the `time_bucket` parameter, with a calculated value when there is no data in the database.</p> There are five options available; `none`, `null`, `linear`, `previous`, fixed integer value.</p> `none` will ignore the group. `null`, `previous` and fixed integer value will be added as the value for the empty group. `linear` will perform a linear regression to calculated the groups' value.</p> The default is `none`.",
    )
    group_by_selector: Optional[bool] = Field(
        None,
        description="Defines whether to group all filtered data into one result or separates the results for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair defined in the `selector` parameter.",
    )
    order: Optional[Order] = None
    selectors: List[Selector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to retrieve the data payloads.",
    )
    start_time: datetime = Field(
        ...,
        description="Start time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2023-06-01T12:00:00.000000Z'.",
        example="2023-06-01T12:00:00.000000Z",
    )
    time_bucket: Optional[str] = Field(
        None,
        description="Group the data by time frame for the `agg` parameter calculations.</p> The time can be adjusted with these time units `ns`, `ms`, `s`, `m`, `h`. e.g. `8765h` equates to is 8,765 hours which is approximately one year.",
    )
    time_shift: Optional[str] = Field(
        None,
        description="Shift the time buckets from the epoch. Every time bucket starts from epoch so, if you want to calculate the time bucket starting on a different date and time, you'll need to set this. Example: `5m`, `1h`, `1w`.",
    )


class TimeseriesList(DataModelBase):
    """
    TimeseriesList object.

    Parameters
    ----------
    resource: Optional[List[str]]
    source: Optional[List[str]]

    """

    resource: Optional[List[str]] = None
    source: Optional[List[str]] = None


class UnitCreate(DataModelBase):
    """
    UnitCreate object.

    Parameters
    ----------
    name: str
    symbol: str
    title: str

    """

    name: str = Field(..., max_length=64, min_length=1)
    symbol: str = Field(..., max_length=16, min_length=1)
    title: str = Field(..., max_length=64, min_length=1)


class UnitUpdate(DataModelBase):
    """
    UnitUpdate object.

    Parameters
    ----------
    symbol: Optional[str]
    title: Optional[str]

    """

    symbol: Optional[str] = Field(None, max_length=16, min_length=1)
    title: Optional[str] = Field(None, max_length=64, min_length=1)


class UserSettingUpdate(DataModelBase):
    """
    UserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class WorkloadDeploy(DataModelBase):
    """
    WorkloadDeploy object.

    Parameters
    ----------
    acp_name: Optional[str]
    app_name: str
    app_version: Optional[str]
    cluster_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    acp_name: Optional[str] = Field(None, max_length=64)
    app_name: str
    app_version: Optional[str] = None
    cluster_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=32)
    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = Field(None, max_length=64)


class AssetCreate(DataModelBase):
    """
    AssetCreate object.

    Parameters
    ----------
    asset_type_name: str
    entity_type_name: str
    hierarchy: Optional[List[AssetCreate]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str

    """

    asset_type_name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> As this is creating additional <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>, the parameters here are the same as the Create Kelvin Asset.",
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetCreateWithParent(DataModelBase):
    """
    AssetCreateWithParent object.

    Parameters
    ----------
    asset_type_name: str
    entity_type_name: str
    hierarchy: Optional[List[AssetCreate]]
    name: str
    parent_name: Optional[str]
    properties: Optional[List[AssetPropertyCreate]]
    title: str

    """

    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> A 400 error will occur if the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> does not exist and this API request will fail.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    parent_name: Optional[str] = Field(
        None,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> to assign as the parent to this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> The <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy\' target=\'_blank\'>hierarchy</a> of <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a> must be followed. For example a <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part" target="_blank">Kelvin Asset Part\'s</a> parent must have an entity type `component`. This parameter can be check in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that is linked to the existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetUpdate(DataModelBase):
    """
    AssetUpdate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    hierarchy: Optional[List[AssetCreate]]
    properties: Optional[List[AssetPropertyCreate]]
    title: str

    """

    asset_type_name: Optional[str] = Field(
        None,
        description='New link to a unique identifier name for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='New optional display name (title) for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class ClusterSetting(DataModelBase):
    """
    ClusterSetting object.

    Parameters
    ----------
    auto_update: Optional[ClusterSettingAutoUpdate]
    forward_logs: Optional[ClusterSettingForwardLogs]
    sync: Optional[ClusterSettingSync]
    telemetry: Optional[ClusterSettingTelemetry]

    """

    auto_update: Optional[ClusterSettingAutoUpdate] = None
    forward_logs: Optional[ClusterSettingForwardLogs] = None
    sync: Optional[ClusterSettingSync] = None
    telemetry: Optional[ClusterSettingTelemetry] = None


class ClusterUpdate(DataModelBase):
    """
    ClusterUpdate object.

    Parameters
    ----------
    forward_logs_buffer_size: Optional[int]
    forward_logs_enabled: Optional[bool]
    manifests_scrape_enabled: Optional[bool]
    manifests_scrape_interval: Optional[int]
    ready: Optional[bool]
    sync_scrape_interval: Optional[int]
    telemetry_buffer_size: Optional[int]
    telemetry_enabled: Optional[bool]
    telemetry_scrape_interval: Optional[int]
    title: Optional[str]
    version: Optional[ClusterVersions]

    """

    forward_logs_buffer_size: Optional[int] = None
    forward_logs_enabled: Optional[bool] = None
    manifests_scrape_enabled: Optional[bool] = None
    manifests_scrape_interval: Optional[int] = None
    ready: Optional[bool] = None
    sync_scrape_interval: Optional[int] = None
    telemetry_buffer_size: Optional[int] = None
    telemetry_enabled: Optional[bool] = None
    telemetry_scrape_interval: Optional[int] = None
    title: Optional[str] = None
    version: Optional[ClusterVersions] = None


class DatastreamExtraField(DataModelBase):
    """
    DatastreamExtraField object.

    Parameters
    ----------
    computation: Optional[DatastreamExtraFieldComputation]
    datastream_name: Optional[str]
    name: Optional[str]

    """

    computation: Optional[DatastreamExtraFieldComputation] = None
    datastream_name: Optional[str] = Field(
        None,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> name to retrieve the data. This is used in connection with the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve relevant data from each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> `extra_field`.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class ExecuteDeploymentRequest(DataModelBase):
    """
    ExecuteDeploymentRequest object.

    Parameters
    ----------
    mappings: Optional[Mappings]
    resources: Optional[List[str]]

    """

    mappings: Optional[Mappings] = None
    resources: Optional[List[str]] = None


class HierarchyUpdate(DataModelBase):
    """
    HierarchyUpdate object.

    Parameters
    ----------
    data: Optional[List[HierarchyUpdateItem]]

    """

    data: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A dictionary with a data property of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> with their <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> structure to update.",
    )


class KelvinClusterInstanceSettingUpdate(DataModelBase):
    """
    KelvinClusterInstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[ClusterSetting]

    """

    payload: Optional[ClusterSetting] = None


class RecommendationActions(DataModelBase):
    """
    RecommendationActions object.

    Parameters
    ----------
    control_changes: Optional[List[RecommendationControlChange]]

    """

    control_changes: Optional[List[RecommendationControlChange]] = Field(
        None,
        description="An array of objects with <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> creation information, if the Recommendation is accepted by the operator.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> does not need to be related to the `resource` of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.",
    )


class RecommendationCreate(DataModelBase):
    """
    RecommendationCreate object.

    Parameters
    ----------
    actions: Optional[RecommendationActions]
    confidence: Optional[int]
    custom_identifier: Optional[str]
    description: Optional[str]
    expiration_date: Optional[str]
    metadata: Optional[Dict[str, Any]]
    resource: str
    source: str
    type: str

    """

    actions: Optional[RecommendationActions] = None
    confidence: Optional[int] = Field(
        None,
        description="Confidence level of the Recommendation.</p> This is a 32-bit signed integer from -2,147,483,648 to 2,147,483,647.</p> This is usually related to any machine learning model results that triggered this <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.",
    )
    custom_identifier: Optional[str] = Field(None, description="An optional identifier.")
    description: Optional[str] = Field(
        None,
        description="Detailed description of this <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.",
    )
    expiration_date: Optional[str] = Field(
        None,
        description="Time of expiry of this <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> in ISO 8601 UTC date/time format. Example; \"2022-07-08T08:41:01.657916Z\".</p> After the defined time, the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will no longer accept any update accept or update reject API requests.",
    )
    metadata: Optional[Dict[str, Any]] = Field(
        None,
        description="Custom dictionary keys/values for use by clients for anything useful and related to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.",
    )
    resource: str = Field(
        ...,
        description="The asset or API that this <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> is related to.</p> This string always starts with `krn:`, then has `asset:`, then the name of the Kelvin Asset.</p> Even though there are other `krn` options it needs to be `asset:` so that it is associated with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a> will be seen in the Asset List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/' target='_blank'>Kelvin Maps</a>.</p> For example `krn:asset:demo-asset`",
    )
    source: str = Field(
        ...,
        description="The user or workload that created this <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation</a>.<p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end.</p> This string always starts with `krn:`, then has either `user:` or `api:` followed by the user name, email or api id.</p> For example `krn:user:my.name@company.com` or `krn:user:api:app-recommendation:4.0.0`.",
    )
    type: str = Field(
        ...,
        description="Unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Type</a>.</p> This must contain only lowercase alphanumeric characters. The `:`, `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> The type must already exist from a list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a>. A full list of available <a href='https://docs.kelvininc.com/latest/kelvin-overview/technologies/recommendations/' target='_blank'>Recommendation Types</a> can be retrieved using the api request `/recommendations/types/list`.",
    )


class TimeseriesBulkCreate(DataModelBase):
    """
    TimeseriesBulkCreate object.

    Parameters
    ----------
    data: Optional[List[TimeseriesCreate]]

    """

    data: Optional[List[TimeseriesCreate]] = None


class AssetInsightsExtraFields(DataModelBase):
    """
    AssetInsightsExtraFields object.

    Parameters
    ----------
    apps: Optional[List[AppExtraField]]
    asset_properties: Optional[List[AssetPropertyExtraField]]
    control_changes: Optional[List[ControlChangeExtraField]]
    datastreams: Optional[List[DatastreamExtraField]]
    recommendations: Optional[List[RecommendationExtraField]]

    """

    apps: Optional[List[AppExtraField]] = None
    asset_properties: Optional[List[AssetPropertyExtraField]] = Field(
        None,
        description="Create new columns based on the `property` field in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> Multiple columns can be created based with each column related to one custom <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> `property` field.",
    )
    control_changes: Optional[List[ControlChangeExtraField]] = None
    datastreams: Optional[List[DatastreamExtraField]] = Field(
        None,
        description="Create new columns based on mathematical calculations for a time range of a data stream for a defined <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> Multiple columns can be created each with its own defined mathematical formula and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )
    recommendations: Optional[List[RecommendationExtraField]] = None


class GetAssetsInsights(DataModelBase):
    """
    GetAssetsInsights object.

    Parameters
    ----------
    asset_names: Optional[List[str]]
    asset_types: Optional[List[str]]
    extra_fields: Optional[AssetInsightsExtraFields]
    pinned_assets: Optional[List[str]]
    search: Optional[List[str]]
    sort_by: Optional[List[AssetInsightsSortBy]]

    """

    asset_names: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> parameter `name`. This can be used alone or with the `search` parameter where the filter will apply to the search results. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> with the name `pump` but not with the names `pumps` or `centrifugal-fan`.",
    )
    asset_types: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> parameter `name`. This can be used alone or with the `search` parameter where the filter will apply to the search results. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> with the name `pump` but not with the names `pum`",
    )
    extra_fields: Optional[AssetInsightsExtraFields] = None
    pinned_assets: Optional[List[str]] = Field(
        None,
        description="List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> names that should always appear at the top of page 1 of any search results.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Search and filter on <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>. Both the Display Name and the Name will be included in the search field criteria. This is given as an array, for example `[pump,fan]`.</p> The search is case insensitive and will find partial matches as well. For example if a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name or display name is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )
    sort_by: Optional[List[AssetInsightsSortBy]] = Field(
        None, description="Options on sorting the returned results"
    )


HierarchyUpdateItem.update_forward_refs()
AssetCreate.update_forward_refs()
